// Copyright distributed.net 1997-1999 - All Rights Reserved
// For use in distributed.net projects only.
// Any other distribution or use of this source violates copyright.
//
// $Log: RC5Dialogs.h,v $
// Revision 1.6.2.3  1999/07/11 03:23:20  sampo
// it's official: I'm dumb
//
// Revision 1.6.2.2  1999/07/11 00:30:05  sampo
// simplify general config panel, add ability to set in and out buffers to different sizes.
//
// Revision 1.6.2.1  1999/05/18 03:28:31  sampo
// large block support added to mac configuration
//
// Revision 1.6  1999/03/22 05:53:28  dicamillo
// Update to support client_loadorder instead of preferred_contest
//
// Revision 1.5  1999/01/10 05:59:48  dicamillo
// Settings changes to match current common code.
//
// Revision 1.4  1999/01/06 06:18:06  dicamillo
// Update for one checkpoint file for all contests.
//
// Revision 1.3  1999/01/01 02:45:17  cramer
// Part 1 of 1999 Copyright updates...
//
// Revision 1.2  1998/12/31 08:24:31  dicamillo
// Constant kMacOSMPCheckItem replaces kMacOSFontsCheckItem.
//
// Revision 1.1  1998/12/15 06:16:34  dicamillo
// First Checked In.
//

// Only need to include the prefs we change in dialogs
// ** when changing this, also change copy_settings_to_client,
//    copy_settings_from_client, and compare_dialog_settings.  **
typedef struct {	
	char id[64];
	s32 inthreshold[CONTEST_COUNT];
	s32 outthreshold[CONTEST_COUNT];
	s32 blockcount;
	s32 minutes;
	char logname[128];
	char keyproxy[64];
	s32 keyport;
	char httpproxy[64];
	s32 httpport;
	s32 uuehttpmode;
	char httpid[128];
    s32 cputype;
	s32 messagelen;
    char smtpsrvr[128];
    s32 smtpport;
    char smtpfrom[128];
    char smtpdest[128];
    s32 numcpu;
    char checkpoint_file[128];
    s32 preferred_blocksize;
    char loadorder_map[CONTEST_COUNT];
	s32 offlinemode;
	s32 percentprintingoff;
	int autofindkeyserver;
	} dialog_settings;

#define MAX_TICKS		60000
#define LOW_TICKS		2000
#define MEDIUM_TICKS	500
#define HIGH_TICKS		65
#define MIN_TICKS		30

#define kConfigOKItem				1
#define kConfigCancelItem			2
#define kConfigEMailLabelItem		3
#define kConfigEMailTextItem		4
#define kConfigIconLabelItem		5
#define kConfigIconGeneralItem		6
#define kConfigIconFileItem			7
#define kConfigIconCPUItem			8
#define kConfigIconNetworkItem		9
#define kConfigIconMacOSItem		10

#define kGeneralOKItem				1
#define kGeneralCancelItem			2
#define kGeneralDefaultItem			3
#define kBlockSizePopupItem			4
#define kGeneralRC5BufferLabelItem	5
#define kGeneralRC5BufferTextItem	6
#define kGeneralRC5Slash			7
#define kGeneralRC5BufferTextItem2	8
#define kGeneralDESBufferLabelItem	9
#define kGeneralDESBufferTextItem	10
#define kGeneralDESSlash			11
#define kGeneralDESBufferTextItem2	12
#define kGeneralCountLabelItem		13
#define kGeneralCountTextItem		14
#define kGeneralHoursLabelItem		15
#define kGeneralHoursTextItem		16

#define kNetworkOKItem				1
#define kNetworkCancelItem			2
#define kNetworkDefaultItem			3
#define kNetworkModeLabelItem		4
#define kNetworkMode1ButtonItem		5
#define kNetworkMode3ButtonItem		6
#define kNetworkMode4ButtonItem		7
#define kNetworkMode5ButtonItem		8
#define kNetworkKeyPortLabelItem	9
#define kNetworkKeyPortTextItem		10
#define kNetworkKeyPortStaticItem	11
#define kNetworkKeyAddrLabelItem	12
#define kNetworkKeyAddrTextItem		13
#define kNetworkKeyAddrStaticItem	14
#define kNetworkHTTPPortLabelItem	15
#define kNetworkHTTPPortTextItem	16
#define kNetworkHTTPPortStaticItem	17
#define kNetworkHTTPAddrLabelItem	18
#define kNetworkHTTPAddrTextItem	19
#define kNetworkHTTPAddrStaticItem	20
#define kNetworkUUCheckItem			21
#define kNetworkHTTPCheckItem		22
#define kNetworkSOCKS4CheckItem		23
#define kNetworkSOCKS5CheckItem		24
#define kNetworkIDStaticItem		25
#define kNetworkIDButton			26
#define kNetworkEMailButton			27

#define kMacOSOKItem				1
#define kMacOSCancelItem			2
#define kMacOSDefaultItem			3
#define kMacOSRespLabelItem			4
#define kMacOSLowButtonItem			5
#define kMacOSMediumButtonItem		6
#define kMacOSHighButtonItem		7
#define kMacOSCustomButtonItem		8
#define kMacOSEveryLabelItem		9
#define kMacOSTicksTextItem			10
#define kMacOSTicksLabelItem		11
#define kMacOSMaxCPUCheckItem		12
#define kMacOSBeginLabelItem		13
#define kMacOSBeginTextItem			14
#define	kMacOSBeginMinsLabelItem	15
#define kMacOSMaxLabelItem			16
#define kMacOSMaxTextItem			17
#define	kMacOSMaxMinsLabelItem		18
#define kMacOSFGCheckItem			19
#define kMacOSFGMoveLabelItem		20
#define kMacOSFGMoveTextItem		21
#define kMacOSFGMinLabelItem		22
#define kMacOSMPCheckItem			23
#define kMacOSResumeCheckItem		24

#define kCPUOKItem					1
#define kCPUCancelItem				2
#define kCPUDefaultItem				3
#define kCPUTypeLabelItem			4
#define kCPUTypeAutoItem			5
#define	kCPUType601Item				6
#define kCPUType603Item				7
#define kCPUCountLabelItem			8
#define kCPUCountAllItem			9
#define kCPUCountUserItem			10
#define	kCPUCountUserEditItem		11

#define kIDOKItem					1
#define kIDCancelItem				2
#define kIDUserStaticItem			3
#define kIDPassStaticItem			4
#define kIDUserTextItem				5
#define kIDPassTextItem				6

#define kEMailOKItem				1
#define kEMailCancelItem			2
#define kEMailDefaultItem			3
#define kEMailTitleItem				4
#define kEMailSMTPAddrLabelItem		5
#define kEMailSMTPAddrTextItem		6
#define kEMailSMTPPortLabelItem		7
#define kEMailSMTPPortTextItem		8
#define kEMailLengthLabelItem		9
#define kEMailLengthTextItem		10
#define kEMailFromLabelItem			11
#define kEMailFromTextItem			12
#define kEMailToLabelItem			13
#define kEMailToTextItem			14
#define kEMailNoMailLabelItem		15

#define kFilesOKItem				1
#define kFilesCancelItem			2
#define kFilesDefaultItem			3
#define kFilesCheckpointLabelItem	4
#define kFilesCheckpointTextItem	5
#define kFilesLogLabelItem			6
#define kFilesLogTextItem			7
