// Copyright distributed.net 1997-1999 - All Rights Reserved
// For use in distributed.net projects only.
// Any other distribution or use of this source violates copyright.
//
// $Log: apputils.h,v $
// Revision 1.2.2.1  1999/05/18 03:27:32  sampo
// large block support added to mac configuration
//
// Revision 1.2  1999/01/01 02:45:17  cramer
// Part 1 of 1999 Copyright updates...
//
// Revision 1.1  1998/12/15 06:13:48  dicamillo
// First Checked In.
//

/* routine descriptors for filter routines */

extern RoutineDescriptor DlgFilter0RD;
extern RoutineDescriptor DlgFilter1RD;
extern RoutineDescriptor DlgFilter2RD;
extern RoutineDescriptor DlgFilter3RD;

// cursor handling
extern Boolean waitcursor;			// true for watch cursor
extern Boolean ibeamcursor;			// true for I-beam cursor

/* prototypes for functions in apputils.c */

StringPtr GetRString(StringPtr theString, int theIndex);
void GetEString(StringPtr theString, int theIndex);
long GetRLong(int index);
short GetResDWRD(OSType type, short resum);
long GetResLWRD(OSType type, short resnum);
void enable_menu_item(MenuHandle theMenu, short item,
					  char enableflag);
void notifyuser(Boolean notifyavail, Boolean *nmrec_installed,
				NMRec *my_nmrec);
void std_showerr(char *s, GrafPtr front_window);
void std_showmsg(char *s, GrafPtr front_window, short alert_kind);
void show_message_string(short error_index, WindowPtr front_window,
						 short alert_kind);
void show_error_string(short error_index, WindowPtr front_window);
void ctralrt(short alertnum, short c_denom);
void ctrwindow(GrafPtr wp, short c_denom, short border_height,
			   short h_offset, short v_offset);
void ctrstdfile(short dlgnum, Point *p, Boolean small_screen,
				Rect *screen_rect, short c_denom);
short get_mbar_height(void);
void clip_rect(Rect *clipRect, Rect *maxRect, Boolean includeScroll);
void framedflt(DialogPtr dlgptr, Boolean color_mac);
Boolean colordialog(DialogPtr dialogwindow, Boolean color_mac);
void get_port_color_info(Boolean color_mac, SInt16 *depth, Boolean *isColor);
void myPlotIconID(Rect *iconrect, short plotalign, short plottype,
				  short iconresnum, Boolean color_mac);
void OutlineButton(ControlHandle button, Boolean usecolor);
void set_initial_zoom(WindowPtr theWindow);
void GetGlobalRect(WindowPtr window, Rect *globalRect);
OSErr dialog_text_adjust(DialogPtr dlgptr, short textitem,
						 short minheight,
						 short item1, short item2, short item3,
						 short item4, short item5, short item6);
OSErr alert_text_adjust(short alertnum, short textitem,
						short minheight,
						short item1, short item2, short item3,
						short item4, short item5, short item6);
OSErr item_text_adjust(char alertflag, DialogPtr dlgptr, short alertnum,
					   short textitem, short minheight,
					   short item1, short item2, short item3,
					   short item4, short item5, short item6);
void define_text(unsigned char *textbuff, TEHandle th);
void define_text_buffer(unsigned char **textbuff, unsigned char *resultbuff,
						short maxresultlen, short *resultlen);
void adjustitem(DialogPtr dlgptr, short itemno, short adjustment);
void adjustalrtitem(ItemTHndl ditlhandle, short itemno, short adjustment);
OSErr getdlgtextitem(ItemTHndl itemhandle, short itemnum,
					 Rect *itemrect, unsigned char *textbuff);
OSErr getdlgitem(ItemTHndl itemhandle, short itemnum, ItemIPtr *infoptr);
OSErr dlgnewmap(GrafPtr wp, Rect *box, unsigned char **mapptr);
short getit(short item, DialogPtr dlgptr);
void setit(short item, DialogPtr dlgptr, short code);
void setactive(short item, DialogPtr dlgptr, char flag, char colormac);
void settext(Handle gitem, char *new_text);
void set_control_text(Handle gitem, char *new_text);
void set_text_cursor(DialogPtr dlgptr, short item);
pascal Boolean DlgFilter0(DialogPtr dlg, EventRecord *eventptr,
						  short *itemptr);
pascal Boolean DlgFilter1(DialogPtr dlg, EventRecord *eventptr,
						  short *itemptr);
pascal Boolean DlgFilter2(DialogPtr dlg, EventRecord *eventptr,
						  short *itemptr);
pascal Boolean DlgFilter3(DialogPtr dlg, EventRecord *eventptr,
						  short *itemptr);
Boolean myDlgFilter(DialogPtr dlg, EventRecord *eventptr,
						  short *itemptr, short cancelnum);
void do_filter_update(GrafPtr thePort);
Boolean longSectRect(LongRect *r, LongRect *s);
void mySetCursor(short cursor_type);
void redrawCursor(void);
OSErr get_res_handle(Handle *resultHandle, OSType resType, short resNum);
short font_name_to_item(MenuHandle mh, char *font_name);
short font_size_to_item(MenuHandle mh, short font_size);
void delete_rect_from_rgn(Rect *r, RgnHandle theRgn, RgnHandle workRgn);
OSErr GetSystemVersion(short *major_version, char *version_text);
void pstrcpy (StringPtr to, StringPtr from);
short myGetNumProcs(Boolean *haveFinder);
/*void pause(short secs);*/

// Various constants for apputils code
	//cursor
#define kInitCursor		0
#define kNextCursor		1
#define kArrowCursor	2
#define kWatchCursor	3
#define kIbeamCursor	4
	// windows
const short kdBoxProcHeight = 7;
const short kAlertBorderHeight = 7;
const short kStdFileBorderHeight = 7;
const short kCenterDefault = 3;
const short kCenterHigh = 8;
const short kCenterLow = 2;
const short kDefaultMBarHeight = 20;
	// Button framing
const short kButtonFrameSize = 3;	// button frame's pen size
const short kButtonFrameInset = -4;	// inset rectangle adjustment around button
const short kButtonOvalSize = 16;	// oval size for FrameRoundRect
	// custom StandardFile dialogs
const short myPutDlgID = 3999;
const short myGetDlgID = 4000;
