// Copyright distributed.net 1997-1999 - All Rights Reserved
// For use in distributed.net projects only.
// Any other distribution or use of this source violates copyright.
//
// $Log: resdefs.h,v $
// Revision 1.3.2.1  1999/05/18 03:28:37  sampo
// large block support added to mac configuration
//
// Revision 1.3  1999/01/07 03:20:05  dicamillo
// Add constant for "OS too new" error.
//
// Revision 1.2  1999/01/01 02:45:17  cramer
// Part 1 of 1999 Copyright updates...
//
// Revision 1.1  1998/12/15 06:16:48  dicamillo
// First Checked In.
//

/* Note: This file is shared by C/C++ code and Res for resource generation */
/* (can't use "const" or // commenting)

/* our signature */
#define kSignature		'RC5C'
#define kPrefsSignature	'RC5P'

/* default preferences file name */
#define DEFAULT_PREFS_NAME "RC5DES Client Preferences"

/* our FREF resource number */
#define kAppFREFNum		128
#define kPrefsFREFNum	129

/* About box */
#define kAboutUserItem	5
#define kAboutIcon		128
#define kAboutText		1500

/* error alert kinds */
#define NOTE_ALERT_KIND		1
#define CAUTION_ALERT_KIND	2
#define STOP_ALERT_KIND 	3

/* STR# configuration  resources */
#define kConfigResourceNum	1000
#define kAboutItemName		1
#define kAboutProgramName	2
#define kConsoleLogName		3

#define kFontsList			2000

#define kErrorResourceNum		4000
#define kSysVersError			1
#define kGetFCBError			2
#define kMPError				3
#define kNoMPWarning			4
#define kMemLowWarning			5
#define kNetInitError			6
#define kMemInitError			7
#define kCPUCfigError			8
#define kGestaltInstallError	9
#define kMPInitError			10
#define kCPUTimesError			11
#define kMemHelpError			12
#define kClientInitError		13
#define kSysTooNewError			14

#define kIconLabelsNum			6000
#define kIconGeneralLabel1		1
#define kIconGeneralLabel2		2
#define kIconFileLabel1			3
#define kIconFileLabel2			4
#define kIconCPULabel1			5
#define kIconCPULabel2			6
#define kIconNetworkLabel1		7
#define kIconNetworkLabel2		8
#define kIconMacOSLabel1		9
#define kIconMacOSLabel2		10

/* other resources */
#define kWatchCursorResnum	3000

/* menus */
#define kNMenus		6
#define kFileMSize	20		/* item number for Quit in File menu */
	/* these are assumed to always be present */
#define kAppleMenu	256
#define kFileMenu	257
#define kEditMenu	258
	/* define these as 0 if not present */
#define kFontMenu	259
#define kSizeMenu	260
#define kStyleMenu	261
#define kBufferMenu 309
	/* apple menu added items */
#define kHelpItem		2
	/* file menu items added */
#define kShowLogItem		1
#define kShowStatusItem		2
#define kCloseItem			3
#define kRunItem			5
#define kRunOfflineItem 	6
#define kRunBuffersItem 	7
#define kBenchmarkRC5Item	9
#define kBenchmarkDESItem	10
#define kTestItem			11
#define kFetchItem			13
#define kFlushItem			14
#define kUpdateItem			15
#define kQuitAppsItem		17
#define	kHaltItem			19
	/* edit menu added items */
#define kPreferencesItem 	 10

/* Dialog/Alert resources */
#define kShowerrAlert		256
#define kAboutDialog		257
#define kSettingsAlert2		280
#define kSettingsAlert3		281
#define kConfigureDialog	300
#define kGeneralDialog		301
#define kNetworkDialog		302
#define kMacOSDialog		303
#define kCPUDialog			304
#define kAltCPUDialog		305
#define kIDDialog			306
#define kEMailDialog		307
#define kFilesDialog		308
#define kRC5Icon			1000
#define kFileIcon			1001
#define kCPUIcon			1002
#define kNetworkIcon		1003
#define kMacOSIcon			1004

/* codes for TextEdit functions */
#define idle_function		1
#define cut_function		2
#define	copy_function		3
#define paste_function		4
#define delete_function		5
#define select_all_function	6
#define undo_function		7
