/* Copyright distributed.net 1997-1999 - All Rights Reserved			*/
/* For use in distributed.net projects only.							*/
/* Any other distribution or use of this source violates copyright.		*/
/*																		*/
/* $Log: version.r,v $
/* Revision 1.31.2.3  1999/07/24 02:42:25  sampo
/* syncing between branches
/*
/* Revision 1.31.2.2  1999/07/11 00:30:14  sampo
/* simplify general config panel, add ability to set in and out buffers to different sizes.
/*
/* Revision 1.31.2.1  1999/07/07 18:43:51  sampo
/* bump up RAM alloc to avoid networking bugs, bump version to beta 3 in case this gets distributed so I can differentiate it from previous builds.
/*
/* Revision 1.31  1999/03/23 06:35:34  dicamillo
/* 1.6.2 for first 439 build
/*
/* Revision 1.30  1999/02/03 20:05:08  sampo
/* chop off the '2' in CLIENT_VERSIONSTRING2 to match change to version.h
/*
/* Revision 1.29  1999/01/17 23:51:32  dicamillo
/* 1.6.1 for 432a
/*
/* Revision 1.28  1999/01/17 08:30:33  dicamillo
/* Finally 1.6.0!
/*
/* Revision 1.27  1999/01/14 03:00:26  sampo
/* new version scheme and increment to fc2
/*
/* Revision 1.26  1999/01/11 02:39:38  dicamillo
/* Update to 1.6fc1 with new icons.
/*
/* Revision 1.25  1999/01/10 08:29:31  dicamillo
/* Update to 1.6b17 for random number fix.
/*
/* Revision 1.24  1999/01/10 06:02:14  dicamillo
/* Update to 1.6b16 for settings changes and restart support.
/*
/* Revision 1.23  1999/01/07 03:20:22  dicamillo
/* Update to 1.6b15 for more fixes.
/*
/* Revision 1.22  1999/01/06 22:25:27  dicamillo
/* Update to 1.6b14 for even more fixes.
/*
/* Revision 1.21  1999/01/06 07:35:29  dicamillo
/* Update to 1.6b13 for many bug fixes.
/*
/* Revision 1.20  1999/01/03 06:26:28  dicamillo
/* Update to 1.6b12 for storage size change.
/*
/* Revision 1.19  1999/01/03 05:01:58  dicamillo
/* Update date to today.
/*
/* Revision 1.18  1999/01/03 05:01:07  dicamillo
/* Update to 1.6b11 for storage increase and checkpoint_file fix.
/*
/* Revision 1.17  1999/01/03 02:29:57  dicamillo
/* Update to 1.6b10 for settings bug fix and new help text.
/*
/* Revision 1.16  1999/01/02 22:48:54  dicamillo
/* Update to 1.6b9 for today's settings fixes.
/*
/* Revision 1.15  1999/01/01 02:45:18  cramer
/* Part 1 of 1999 Copyright updates...
/*
/* Revision 1.14  1999/01/01 01:42:30  vetere
/* Copyright is now a resource.
/*
/* Revision 1.13  1998/12/31 08:27:53  dicamillo
/* Updated to 1.6b7 for complete event support and "Use MP Support" setting.
/*
/* Revision 1.12  1998/12/30 07:40:18  dicamillo
/* Updated to 1.6b6 for more event support.
/*
/* Revision 1.11  1998/12/29 09:38:33  dicamillo
/* Updated to 1.6b5 for initial event support.
/*
/* Revision 1.10  1998/12/28 20:59:21  vetere
/* Get Info dlog changes and 1.6b4.
/*
/* Revision 1.9  1998/12/25 20:21:59  vetere
/* Build version is now drawn from version.h
/*
/* Revision 1.8  1998/12/25 15:01:02  vetere
/* Hiked version again (423).
/*
/* Revision 1.7  1998/12/24 05:46:12  dicamillo
/* Updated Mac version date, and updated version to 1.6b3.
/*
/* Revision 1.6  1998/12/22 03:07:33  sampo
/* Bump version to 2.7102.421 from 2.7100.422.
/*
/* Revision 1.5  1998/12/22 02:52:35  silby
/* Reverted back to 1.3 at sampo's request.
/*
/* Revision 1.3  1998/12/15 20:28:23  sampo
/* Bump version to 2.7102.421 from 2.7100.420
/*
/* Revision 1.2  1998/12/15 03:45:34  dicamillo
/* First checked in; fixed CVS log format.
/*																*/

#include "Types.r"
#include "SysTypes.r"
#include "resdefs.h"
#include "version.h"

#define the_datestr "23 July 1999"
#define the_copystr "1997-1999 distributed.net"
#define the_majorver 0x1
#define the_minorver 0x63
#define the_stage beta
#define the_build 5
#define the_verstr "1.6.3b5"

resource 'vers' (1, preload) {
	the_majorver,
	the_minorver,
	the_stage,
	the_build,
	verUs,
	the_verstr,
	 CLIENT_VERSIONSTRING "/" the_verstr "\nBuilt " the_datestr
};

resource 'vers' (2, preload) {
	the_majorver,
	the_minorver,
	the_stage,
	the_build,
	verUs,
	the_verstr,
	the_copystr
};

type kSignature {
		pstring;
};

resource kSignature (0, preload) {
	the_verstr " (" the_datestr ")"
};

resource kSignature (1, preload) {
	the_copystr
};
